#!/usr/bin/env python
# -*- coding: latin-1 -*-
# ------------------------------------------------------------------------------------
# read caltab from single channel device
# version 1
# used python 2.7.16 and pyserial-2.7
# ------------------------------------------------------------------------------------
# SETTINGS ... change for your own needs
COMPORT = "COM6"
DATAFILE = "dataw.cal"
# ------------------------------------------------------------------------------------
COMPORT_TIMEOUT = 1			# in seconds
COMPORT_SPEED =57600		# in baud
DEBUG=0
import serial,time

#---------------------------------------
#main
#---------------------------------------

print "write calibration to FOTEMP"
print ""
print "for writing to module 1, the file <data_write_ch1.cal> is expected"
print "for writing to module 2, the file <data_write_ch2.cal> is expected"
print "for writing to module 3, the file <data_write_ch3.cal> is expected"
print "for writing to module 4, the file <data_write_ch4.cal> is expected"

comport=int(raw_input("Which COM (number only)? "))
module=int(raw_input("Which module (1-8)? "))
if module==1: datafile="data_write_module1.cal"
if module==2: datafile="data_write_module2.cal"
if module==3: datafile="data_write_module3.cal"
if module==4: datafile="data_write_module4.cal"
data = list()
cmd = "A0{0} :74 1".format(module)
f=open(datafile,'r')
for sLine in f:
	rowData = sLine.rsplit()
	#print len(rowData),rowData
	edge = int( rowData[0])
	temp10 = int(rowData[1])
	dataEntry = (edge, temp10)
	data.append(dataEntry)
for entry in data:
		edge, temp = entry
		#print "Edge=", edge, " Temp=", temp
		if temp < 0:
			   temp = 0xffff + temp + 1
		cmd = "{0} {1:X} {2:X}".format(cmd, edge, temp)
ser = serial.Serial("COM"+str(comport), COMPORT_SPEED, timeout=COMPORT_TIMEOUT)
print "used com port: ",ser.name
print "executing "+cmd
ser.write(cmd+"\r\n")
ser.close()
print "done."